package com.caimei365.tools.model.po;

import lombok.Data;

import java.io.Serializable;

/**
 * 用户Entity
 *
 * @author ZCP
 * @version 2017-10-10
 */
@Data
public class CmUserPo implements Serializable {

    private static final long serialVersionUID = 1L;
    private Integer userID;        // userID
    private Integer userOrganizeID;//用户组织ID
    private String mobile;        // 手机号码
    private Integer userPermission;        // 用户权限
    private String email;        // 邮箱
    private String userName;        // 用户名
    private Integer source;         //注册来源: 0网站 1小程序
    private String image;        // image
    private String password;        // 密码
//    private String userLevelID;        // 用户会员等级，见表c_userlevel或枚举UserLevel
    private String name;        // 组织名称
//    private String nick;        // 昵称
//    private String sex;        // 性别
    private String registerUserTypeID;        // 用户类型，见表c_usertype或枚举UserType
//    private String manufacturerFlag;        // 已废弃 是否是供应商，1是 空或0否
    private String manufacturerStatus;        // 供应商状态，见表c_shopstatus或枚举ShopStatus
    private String shopID;        // 供应商Id
//    private String serviceProviderFlag;        // 已废弃  是否创客，1是 空或0否
//    private String clubFlag;        //已废弃  是否会所，1是 空或0否
//    private String masterFlag;        //已废弃  masterFlag
//    private String normalFlag;        //已废弃  normalFlag
    private String auditStatus;        // auditStatus
    private String auditTime;        // auditTime
    private String auditNote;        // auditNote
    private String registerTime;        // 注册时间
    private String registerIP;        // 注册ip
    private String loginTime;        // 登录时间
    private String loginFailTime;        // 登录失败次数
    private String loginIP;        // 登录ip
    private String validFlag;        // 用户状态，1正常，0冻结
//    private String emailCheckFlag;        // emailCheckFlag
//    private String mobileCheckFlag;        // mobileCheckFlag
    private String clubStatus;        // 会所状态，见表c_clubstatus或枚举ClubStatus
    private String clubID;        // 会所Id
    private String agreeFlag;        // agreeFlag
//    private String activationCode;        // activationCode
//    private String activationDate;        // activationDate
    private String serviceProviderStatus;        // 创客状态
    private String serviceProviderID;        // 创客Id
//    private String masterStatus;        // masterStatus
//    private String masterID;        // masterID
    private Double userMoney;        // 账户余额
    private Double ableUserMoney;        //账户可用余额
//    private String point;        // point
//    private String shopERPFlag;        // shopERPFlag
//    private String fromUserID;        // 邀请人Id
//    private String fromUserName;        // 邀请人名称
    private String logoffTime;        // logoffTime
    private String appKey;        // appKey
    private String appSecret;        // appSecret
//    private String sampleFlag;        // sampleFlag
    private String scanFlag;        // 扫描标志(4 CRM拉上来的会所)
//    private String sysroleid;        // sysroleid
//    private String gender;        // gender
//    private String age;        // 年龄
//    private String salerbuyer;        // salerbuyer
//    private String position;        // position
//    private String skill;        // skill
//    private String workage;        // workage
//    private String wechat;        // 微信号
//    private String qq;        // QQ号
//    private String smsFlag;        // 短信是否发送成功
    private Integer userBeans;        // 采美豆数量
//    private String privateShopFlag;        // 平台商标志位  0非平台商 1平台商
//    private String privateClubFlag;        // 平台会所标志位  0非平台会所 1平台会所
//    private String isMeiDaoAuthorized;        // isMeiDaoAuthorized
    private String guideFlag;        // 引导层弹出  0需要弹出  1不需要弹出
    private String nickName;        // 微信昵称
    private String startTime;     //注册时间开始 查询条件
    private String endTime;        //注册时间结束  查询条件
    private String operatorMobile; //


    /**
     * 用户模块重构
     */
    private String account;//账号名： 企业账号登录使用
    private Integer userIdentity;//用户身份
    private String realName;//真实姓名
    private Integer companyUserID;//企业用户id
    private String openID;//微信openID
    private String bindMobile;//企业绑定手机号
    private String tipStatus;//弹窗提示状态
    private String identityDisplay; //前台身份展示
    private String linkMan;//联系人

    //会所用户信息
    private String town; // 区
    private String city; // 市
    private String province; //省
    private String address;        // 详细地址
    private boolean pending = false; //是否有待审核提现
    private String shortName;   //机构简称
    private String userIds;  //用户id","隔开
    private boolean storeStatus = false; //是否存在数据库

   }
